package com.ejie.ab79.model.inspecciones;

import java.util.Date;

import com.ejie.ab79.model.Inspectores;
import com.ejie.ab79.model.expedientes.DatosDirecciones;
import com.ejie.ab79.model.expedientes.Expedientes;
import com.ejie.ab79.model.nora.T17Localidad;
import com.ejie.ab79.model.nora.T17Municipio;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.ab79.model.propuestaSancion.PropuestaSancion;
import com.ejie.ab79.model.protocolos.Protocolos;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Inspecciones  
 * 
 *  
 */

public class Inspecciones implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idInspeccion;
	private String idInspeccionMovil;
	private String identificadorInspeccion;
	private ResultadosInspeccion resultadoInspeccion;
	private Direcciones direccion;
	private Expedientes expediente;
	private CampainasInspeccion campaina;
	private EstadosInspeccion estadoInspeccion;
	private String objetoInspeccion;
	private Date fechaRegistro; // Campo que se utiliza para mostrar la Fecha de
								// Envío de la Inspección
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private DatosDirecciones datosDirecciones;
	private Protocolos idProtocolo;
	private Integer idOrigenInspeccion;
	private Date fechaLimInspeccion;
	private Procedimientos procedimiento;
	private Inspectores inspector;
	private String nRegistro;
	private T17Municipio municipio;
	private T17Localidad localidad;
	private Date fechaAsigInspeccion;
	private String observacionesResultado;

	// Para mostrar en la tabla
	private String munLocalidad;

	// Para el filtrado
	private String idsEstadoInspeccion;
	private String idsResultadoInspeccion;
	private String idsComboEstadoInspeccion;
	private Integer enviadoTablet;
	private Integer casoPropuesta;
	private Integer idPropuesta;

	private Date fechaFinInspeccion;

	private PropuestaSancion propuestaSancion;
	private Agrupaciones agrupacion;

	/**
	 * Method 'Inspecciones'.
	 */
	public Inspecciones() {
	}

	/**
	 * Method 'Inspecciones'.
	 * 
	 * @param idInspeccion
	 *            Integer
	 */
	public Inspecciones(Integer idInspeccion) {
		this.idInspeccion = idInspeccion;
	}

	/**
	 * Method 'Inspecciones'.
	 * 
	 * @param idInspeccion
	 *            Integer
	 * @param idInspeccionMovil
	 *            Integer
	 * @param identificadorInspeccion
	 *            String
	 * @param idResultadoInspeccion
	 *            Integer
	 * @param idDireccion
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param idCampaina
	 *            Integer
	 * @param idEstadoInspeccion
	 *            Long
	 * @param visitaAdministrativa
	 *            Integer
	 * @param objetoInspeccion
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public Inspecciones(Integer idInspeccion, String idInspeccionMovil, String identificadorInspeccion,
			ResultadosInspeccion resultadoInspeccion, Direcciones direccion, Expedientes expediente,
			CampainasInspeccion campaina, EstadosInspeccion estadoInspeccion, String objetoInspeccion,
			Integer idOrigenInspeccion, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion) {

		this.idInspeccion = idInspeccion;
		this.idInspeccionMovil = idInspeccionMovil;
		this.identificadorInspeccion = identificadorInspeccion;
		this.resultadoInspeccion = resultadoInspeccion;
		this.direccion = direccion;
		this.expediente = expediente;
		this.campaina = campaina;
		this.estadoInspeccion = estadoInspeccion;
		this.objetoInspeccion = objetoInspeccion;
		this.idOrigenInspeccion = idOrigenInspeccion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public Inspecciones(Integer idInspeccion, String identificadorInspeccion, ResultadosInspeccion resultadoInspeccion,
			Direcciones direccion, Expedientes expediente, CampainasInspeccion campaina, Protocolos idProtocolo,
			EstadosInspeccion estadoInspeccion, String objetoInspeccion, Integer idOrigenInspeccion, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion) {

		this.idInspeccion = idInspeccion;
		this.identificadorInspeccion = identificadorInspeccion;
		this.resultadoInspeccion = resultadoInspeccion;
		this.direccion = direccion;
		this.expediente = expediente;
		this.campaina = campaina;
		this.idProtocolo = idProtocolo;
		this.estadoInspeccion = estadoInspeccion;
		this.objetoInspeccion = objetoInspeccion;
		this.idOrigenInspeccion = idOrigenInspeccion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdInspeccion'.
	 *
	 * @return Integer
	 */

	public Integer getIdInspeccion() {
		return this.idInspeccion;
	}

	/**
	 * Method 'setIdInspeccion'.
	 *
	 * @param idInspeccion
	 *            Integer
	 * @return
	 */

	public void setIdInspeccion(Integer idInspeccion) {
		this.idInspeccion = idInspeccion;
	}

	/**
	 * Method 'getIdInspeccionMovil'.
	 *
	 * @return Integer
	 */

	public String getIdInspeccionMovil() {
		return this.idInspeccionMovil;
	}

	/**
	 * Method 'setIdInspeccionMovil'.
	 *
	 * @param idInspeccion
	 *            Integer
	 * @return
	 */

	public void setIdInspeccionMovil(String idInspeccionMovil) {
		this.idInspeccionMovil = idInspeccionMovil;
	}

	/**
	 * Method 'getIdentificadorInspeccion'.
	 *
	 * @return String
	 */

	public String getIdentificadorInspeccion() {
		return this.identificadorInspeccion;
	}

	/**
	 * Method 'setIdentificadorInspeccion'.
	 *
	 * @param identificadorInspeccion
	 *            String
	 * @return
	 */

	public void setIdentificadorInspeccion(String identificadorInspeccion) {
		this.identificadorInspeccion = identificadorInspeccion;
	}

	public Integer getIdOrigenInspeccion() {
		return idOrigenInspeccion;
	}

	public void setIdOrigenInspeccion(Integer idOrigenInspeccion) {
		this.idOrigenInspeccion = idOrigenInspeccion;
	}

	public Protocolos getIdProtocolo() {
		return idProtocolo;
	}

	public void setIdProtocolo(Protocolos idProtocolo) {
		this.idProtocolo = idProtocolo;
	}

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaLimInspeccion() {
		return fechaLimInspeccion;
	}

	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaLimInspeccion(Date fechaLimInspeccion) {
		this.fechaLimInspeccion = fechaLimInspeccion;
	}

	/**
	 * Method 'getIdResultadoInspeccion'.
	 *
	 * @return Integer
	 */

	public ResultadosInspeccion getResultadoInspeccion() {
		return this.resultadoInspeccion;
	}

	/**
	 * Method 'setIdResultadoInspeccion'.
	 *
	 * @param idResultadoInspeccion
	 *            Integer
	 * @return
	 */

	public void setResultadoInspeccion(ResultadosInspeccion resultadoInspeccion) {
		this.resultadoInspeccion = resultadoInspeccion;
	}

	/**
	 * Method 'getIdDireccion'.
	 *
	 * @return Integer
	 */

	public Direcciones getDireccion() {
		return this.direccion;
	}

	/**
	 * Method 'setIdDireccion'.
	 *
	 * @param idDireccion
	 *            Integer
	 * @return
	 */

	public void setDireccion(Direcciones direccion) {
		this.direccion = direccion;
	}

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Expedientes getExpediente() {
		return this.expediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setExpediente(Expedientes expediente) {
		this.expediente = expediente;
	}

	/**
	 * Method 'getIdCampaina'.
	 *
	 * @return Integer
	 */

	public CampainasInspeccion getCampaina() {
		return this.campaina;
	}

	/**
	 * Method 'setIdCampaina'.
	 *
	 * @param idCampaina
	 *            Integer
	 * @return
	 */

	public void setCampaina(CampainasInspeccion campaina) {
		this.campaina = campaina;
	}

	/**
	 * Method 'getIdEstadoInspeccion'.
	 *
	 * @return Long
	 */

	public EstadosInspeccion getEstadoInspeccion() {
		return this.estadoInspeccion;
	}

	/**
	 * Method 'setIdEstadoInspeccion'.
	 *
	 * @param idEstadoInspeccion
	 *            Long
	 * @return
	 */

	public void setEstadoInspeccion(EstadosInspeccion estadoInspeccion) {
		this.estadoInspeccion = estadoInspeccion;
	}

	/**
	 * Method 'getObjetoInspeccion'.
	 *
	 * @return String
	 */

	public String getObjetoInspeccion() {
		return this.objetoInspeccion;
	}

	/**
	 * Method 'setObjetoInspeccion'.
	 *
	 * @param objetoInspeccion
	 *            String
	 * @return
	 */

	public void setObjetoInspeccion(String objetoInspeccion) {
		this.objetoInspeccion = objetoInspeccion;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public DatosDirecciones getDatosDirecciones() {
		return datosDirecciones;
	}

	public void setDatosDirecciones(DatosDirecciones datosDirecciones) {
		this.datosDirecciones = datosDirecciones;
	}

	public Procedimientos getProcedimiento() {
		return procedimiento;
	}

	public void setProcedimiento(Procedimientos procedimiento) {
		this.procedimiento = procedimiento;
	}

	public Inspectores getInspector() {
		return inspector;
	}

	public void setInspector(Inspectores inspector) {
		this.inspector = inspector;
	}

	public String getnRegistro() {
		return nRegistro;
	}

	public void setnRegistro(String nRegistro) {
		this.nRegistro = nRegistro;
	}

	public T17Municipio getMunicipio() {
		return municipio;
	}

	public void setMunicipio(T17Municipio municipio) {
		this.municipio = municipio;
	}

	public T17Localidad getLocalidad() {
		return localidad;
	}

	public void setLocalidad(T17Localidad localidad) {
		this.localidad = localidad;
	}

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaAsigInspeccion() {
		return fechaAsigInspeccion;
	}

	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaAsigInspeccion(Date fechaAsigInspeccion) {
		this.fechaAsigInspeccion = fechaAsigInspeccion;
	}

	/**
	 * @return the munLocalidad
	 */
	public String getMunLocalidad() {
		return this.munLocalidad;
	}

	/**
	 * @param munLocalidad
	 *            the munLocalidad to set
	 */
	public void setMunLocalidad(String munLocalidad) {
		this.munLocalidad = munLocalidad;
	}

	/**
	 * Method 'getObservacionesResultado'
	 * 
	 * @return String
	 */
	public String getObservacionesResultado() {
		return this.observacionesResultado;
	}

	/**
	 * Method 'setObservacionesResultado'
	 * 
	 * @param observacionesResultado
	 *            String
	 * @return
	 */
	public void setObservacionesResultado(String observacionesResultado) {
		this.observacionesResultado = observacionesResultado;
	}

	public String getIdsEstadoInspeccion() {
		return this.idsEstadoInspeccion;
	}

	public void setIdsEstadoInspeccion(String idsEstadoInspeccion) {
		this.idsEstadoInspeccion = idsEstadoInspeccion;
	}

	public String getIdsResultadoInspeccion() {
		return this.idsResultadoInspeccion;
	}

	public void setIdsResultadoInspeccion(String idsResultadoInspeccion) {
		this.idsResultadoInspeccion = idsResultadoInspeccion;
	}

	public String getIdsComboEstadoInspeccion() {
		return idsComboEstadoInspeccion;
	}

	public void setIdsComboEstadoInspeccion(String idsComboEstadoInspeccion) {
		this.idsComboEstadoInspeccion = idsComboEstadoInspeccion;
	}

	public Integer getEnviadoTablet() {
		return enviadoTablet;
	}

	public void setEnviadoTablet(Integer enviadoTablet) {
		this.enviadoTablet = enviadoTablet;
	}

	public Integer getCasoPropuesta() {
		return casoPropuesta;
	}

	public void setCasoPropuesta(Integer casoPropuesta) {
		this.casoPropuesta = casoPropuesta;
	}

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFinInspeccion() {
		return fechaFinInspeccion;
	}

	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFinInspeccion(Date fechaFinInspeccion) {
		this.fechaFinInspeccion = fechaFinInspeccion;
	}

	public Integer getIdPropuesta() {
		return idPropuesta;
	}

	public void setIdPropuesta(Integer idPropuesta) {
		this.idPropuesta = idPropuesta;
	}

	public PropuestaSancion getPropuestaSancion() {
		return propuestaSancion;
	}

	public void setPropuestaSancion(PropuestaSancion propuestaSancion) {
		this.propuestaSancion = propuestaSancion;
	}

	public Agrupaciones getAgrupacion() {
		return agrupacion;
	}

	public void setAgrupacion(Agrupaciones agrupacion) {
		this.agrupacion = agrupacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idInspeccion: ").append(this.idInspeccion).append(" ]");
		result.append(", [ identificadorInspeccion: ").append(this.identificadorInspeccion).append(" ]");
		result.append(", [ resultadoInspeccion: ").append(this.resultadoInspeccion).append(" ]");
		result.append(", [ direccion: ").append(this.direccion).append(" ]");
		result.append(", [ expediente: ").append(this.expediente).append(" ]");
		result.append(", [ campaina: ").append(this.campaina).append(" ]");
		result.append(", [ estadoInspeccion: ").append(this.estadoInspeccion).append(" ]");
		result.append(", [ objetoInspeccion: ").append(this.objetoInspeccion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
